/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Fri Jan 11 19:32:53 2013.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2013. All Rights Reserved.
 * 
 * The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved online at http://www.erlang.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_SBMBC (2)
#define ERTS_ALC_A_TEMPORARY (3)
#define ERTS_ALC_A_SHORT_LIVED (4)
#define ERTS_ALC_A_STANDARD (5)
#define ERTS_ALC_A_LONG_LIVED (6)
#define ERTS_ALC_A_EHEAP (7)
#define ERTS_ALC_A_ETS (8)
#define ERTS_ALC_A_FIXED_SIZE (9)
#define ERTS_ALC_A_BINARY (10)
#define ERTS_ALC_A_DRIVER (11)

#define ERTS_ALC_A_MAX (11)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (5)

/* Type numbers used for sbmbc_alloc */
#define ERTS_ALC_N_MIN_A_SBMBC (6)
#define ERTS_ALC_N_MAX_A_SBMBC (6)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (7)
#define ERTS_ALC_N_MAX_A_TEMPORARY (26)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (27)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (58)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (59)
#define ERTS_ALC_N_MAX_A_STANDARD (99)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (100)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (142)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (143)
#define ERTS_ALC_N_MAX_A_EHEAP (146)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (147)
#define ERTS_ALC_N_MAX_A_ETS (155)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (156)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (162)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (163)
#define ERTS_ALC_N_MAX_A_BINARY (164)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (165)
#define ERTS_ALC_N_MAX_A_DRIVER (172)

#define ERTS_ALC_N_MAX (172)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_SBMBC (1)
#define ERTS_ALC_MTA_TEMPORARY (1)
#define ERTS_ALC_MTA_SHORT_LIVED (1)
#define ERTS_ALC_MTA_STANDARD (1)
#define ERTS_ALC_MTA_LONG_LIVED (1)
#define ERTS_ALC_MTA_EHEAP (1)
#define ERTS_ALC_MTA_ETS (1)
#define ERTS_ALC_MTA_FIXED_SIZE (1)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_NBIF_TABLE (337)
#define ERTS_ALC_T_INFO_DSBUF (465)
#define ERTS_ALC_T_HIPE (593)
#define ERTS_ALC_T_PUTENV_STR (721)
#define ERTS_ALC_T_SBMBC (850)
#define ERTS_ALC_T_TMP_HEAP (915)
#define ERTS_ALC_T_MSG_ROOTS (1043)
#define ERTS_ALC_T_ROOTSET (1171)
#define ERTS_ALC_T_LOADER_TMP (1379)
#define ERTS_ALC_T_NC_TMP (1491)
#define ERTS_ALC_T_TMP (1619)
#define ERTS_ALC_T_DCTRL_BUF (1747)
#define ERTS_ALC_T_TMP_DIST_BUF (1875)
#define ERTS_ALC_T_ESTACK (2003)
#define ERTS_ALC_T_PORT_CALL_BUF (2131)
#define ERTS_ALC_T_DB_TMP (2211)
#define ERTS_ALC_T_DB_MC_STK (2339)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2467)
#define ERTS_ALC_T_LOGGER_DSBUF (2643)
#define ERTS_ALC_T_TMP_DSBUF (2771)
#define ERTS_ALC_T_DDLL_TMP_BUF (2899)
#define ERTS_ALC_T_RE_TMP_BUF (3027)
#define ERTS_ALC_T_TEMP_TERM (3155)
#define ERTS_ALC_T_SYS_READ_BUF (3283)
#define ERTS_ALC_T_ENVIRONMENT (3411)
#define ERTS_ALC_T_PEND_SUSPEND (3476)
#define ERTS_ALC_T_PROC_LIST (3604)
#define ERTS_ALC_T_SL_BIF_TIMER (3732)
#define ERTS_ALC_T_DB_FIXATION (3876)
#define ERTS_ALC_T_DB_FIX_DEL (4004)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4132)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4260)
#define ERTS_ALC_T_PORT_TASK (4436)
#define ERTS_ALC_T_PORT_TASKQ (4564)
#define ERTS_ALC_T_MISC_OP_LIST (4692)
#define ERTS_ALC_T_PORT_NAMES (4820)
#define ERTS_ALC_T_PROCS_TPROC_EL (4884)
#define ERTS_ALC_T_PROCS_CNKINF (5012)
#define ERTS_ALC_T_PROCS_PIDS (5140)
#define ERTS_ALC_T_RE_SUBJECT (5332)
#define ERTS_ALC_T_RE_STACK (5460)
#define ERTS_ALC_T_UNICODE_BUFFER (5588)
#define ERTS_ALC_T_BINARY_BUFFER (5716)
#define ERTS_ALC_T_TMP_CPU_IDS (5844)
#define ERTS_ALC_T_EXT_TERM_DATA (5908)
#define ERTS_ALC_T_MISC_AUX_WORK (6100)
#define ERTS_ALC_T_THR_Q_SL (6228)
#define ERTS_ALC_T_ASYNC (6356)
#define ERTS_ALC_T_XPORTS_LIST (6484)
#define ERTS_ALC_T_T_THR_PRGR_DATA (6612)
#define ERTS_ALC_T_ETHR_SL (6740)
#define ERTS_ALC_T_SL_PTIMER (6868)
#define ERTS_ALC_T_SYS_MSG_Q (6932)
#define ERTS_ALC_T_AINFO_REQ (7124)
#define ERTS_ALC_T_SCHED_WTIME_REQ (7252)
#define ERTS_ALC_T_FD_LIST (7380)
#define ERTS_ALC_T_POLLSET_UPDREQ (7508)
#define ERTS_ALC_T_REG_PROC (7573)
#define ERTS_ALC_T_LINK_LH (7701)
#define ERTS_ALC_T_SUSPEND_MON (7829)
#define ERTS_ALC_T_LL_BIF_TIMER (7957)
#define ERTS_ALC_T_REG_TABLE (8149)
#define ERTS_ALC_T_FUN_TABLE (8293)
#define ERTS_ALC_T_DIST_TABLE (8405)
#define ERTS_ALC_T_NODE_TABLE (8533)
#define ERTS_ALC_T_MODULE_REFS (8677)
#define ERTS_ALC_T_DCACHE (8789)
#define ERTS_ALC_T_DIST_ENTRY (8917)
#define ERTS_ALC_T_NODE_ENTRY (9045)
#define ERTS_ALC_T_DRIVER (9173)
#define ERTS_ALC_T_ARG_REG (9237)
#define ERTS_ALC_T_PROC_DICT (9365)
#define ERTS_ALC_T_CALLS_BUF (9493)
#define ERTS_ALC_T_BPD (9685)
#define ERTS_ALC_T_PORT_NAME (9813)
#define ERTS_ALC_T_LINEBUF (9941)
#define ERTS_ALC_T_IOQ (10069)
#define ERTS_ALC_T_BITS_BUF (10197)
#define ERTS_ALC_T_DB_NTAB_ENT (10277)
#define ERTS_ALC_T_DDLL_HANDLE (10453)
#define ERTS_ALC_T_PORT_DATA_LOCK (10581)
#define ERTS_ALC_T_NODES_MON (10645)
#define ERTS_ALC_T_RE_HEAP (10837)
#define ERTS_ALC_T_PSD (10901)
#define ERTS_ALC_T_PRTSD (11093)
#define ERTS_ALC_T_ZLIB (11221)
#define ERTS_ALC_T_THR_Q_EL (11349)
#define ERTS_ALC_T_THR_Q (11477)
#define ERTS_ALC_T_PORT_LOCK (11605)
#define ERTS_ALC_T_DRIVER_LOCK (11733)
#define ERTS_ALC_T_ETHR_STD (11861)
#define ERTS_ALC_T_LL_PTIMER (11989)
#define ERTS_ALC_T_DDLL_PROCESS (12117)
#define ERTS_ALC_T_MONITOR_LH (12181)
#define ERTS_ALC_T_NLINK_LH (12309)
#define ERTS_ALC_T_DB_HEIR_DATA (12453)
#define ERTS_ALC_T_FD_ENTRY_BUF (12629)
#define ERTS_ALC_T_PRT_REP_EXIT (12757)
#define ERTS_ALC_T_ATOM (12870)
#define ERTS_ALC_T_MODULE (13030)
#define ERTS_ALC_T_FUN_ENTRY (13158)
#define ERTS_ALC_T_ATOM_TXT (13254)
#define ERTS_ALC_T_BIF_TIMER_TABLE (13398)
#define ERTS_ALC_T_ATOM_TABLE (13510)
#define ERTS_ALC_T_EXPORT_TABLE (13670)
#define ERTS_ALC_T_MODULE_TABLE (13798)
#define ERTS_ALC_T_TAINT (13926)
#define ERTS_ALC_T_PROC_TABLE (13974)
#define ERTS_ALC_T_PORT_TABLE (14166)
#define ERTS_ALC_T_TIMER_WHEEL (14294)
#define ERTS_ALC_T_ASYNC_DATA (14422)
#define ERTS_ALC_T_DB_TABLES (14502)
#define ERTS_ALC_T_INSTR_INFO (14678)
#define ERTS_ALC_T_SCHDLR_SLP_INFO (14806)
#define ERTS_ALC_T_RUNQS (14934)
#define ERTS_ALC_T_DDLL_ERRCODES (15062)
#define ERTS_ALC_T_PRE_ALLOC_DATA (15190)
#define ERTS_ALC_T_CPUDATA (15318)
#define ERTS_ALC_T_CPU_GRPS_MAP (15446)
#define ERTS_ALC_T_AUX_WORK_TMO (15574)
#define ERTS_ALC_T_MISC_AUX_WORK_Q (15702)
#define ERTS_ALC_T_THR_Q_LL (15830)
#define ERTS_ALC_T_PROC_LCK_WTR (15958)
#define ERTS_ALC_T_RUNQ_BLNS (16086)
#define ERTS_ALC_T_THR_PRGR_IDATA (16214)
#define ERTS_ALC_T_THR_PRGR_DATA (16342)
#define ERTS_ALC_T_ETHR_LL (16470)
#define ERTS_ALC_T_FP_EXCEPTION (16598)
#define ERTS_ALC_T_CODE (16742)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (16806)
#define ERTS_ALC_T_SCHDLR_DATA (16982)
#define ERTS_ALC_T_LL_TEMP_TERM (17110)
#define ERTS_ALC_T_EXPORT (17254)
#define ERTS_ALC_T_DRV_TAB (17366)
#define ERTS_ALC_T_DRV_EV_STATE (17494)
#define ERTS_ALC_T_POLLSET (17622)
#define ERTS_ALC_T_POLL_FDS (17750)
#define ERTS_ALC_T_POLL_RES_EVS (17878)
#define ERTS_ALC_T_FD_STATUS (18006)
#define ERTS_ALC_T_FD_TAB (18134)
#define ERTS_ALC_T_CS_PROG_PATH (18262)
#define ERTS_ALC_T_BEAM_REGISTER (18327)
#define ERTS_ALC_T_HEAP (18455)
#define ERTS_ALC_T_OLD_HEAP (18583)
#define ERTS_ALC_T_HEAP_FRAG (18711)
#define ERTS_ALC_T_DB_TABLE (18856)
#define ERTS_ALC_T_DB_SEG (18984)
#define ERTS_ALC_T_DB_SEG_TAB (19112)
#define ERTS_ALC_T_DB_STK (19240)
#define ERTS_ALC_T_DB_TRANS_TAB (19368)
#define ERTS_ALC_T_DB_SEL_LIST (19496)
#define ERTS_ALC_T_DB_DMC_ERROR (19624)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (19752)
#define ERTS_ALC_T_DB_TERM (19880)
#define ERTS_ALC_T_PROC (19993)
#define ERTS_ALC_T_MSG_REF (20121)
#define ERTS_ALC_T_THR_Q_EL_SL (20313)
#define ERTS_ALC_T_MONITOR_SH (20377)
#define ERTS_ALC_T_NLINK_SH (20505)
#define ERTS_ALC_T_DRV_EV_D_STATE (20697)
#define ERTS_ALC_T_DRV_SEL_D_STATE (20825)
#define ERTS_ALC_T_DRV_BINARY (20922)
#define ERTS_ALC_T_BINARY (21050)
#define ERTS_ALC_T_DRV (21211)
#define ERTS_ALC_T_NIF (21339)
#define ERTS_ALC_T_DRV_THR_OPTS (21467)
#define ERTS_ALC_T_DRV_TID (21595)
#define ERTS_ALC_T_DRV_MTX (21723)
#define ERTS_ALC_T_DRV_CND (21851)
#define ERTS_ALC_T_DRV_RWLCK (21979)
#define ERTS_ALC_T_DRV_TSD (22107)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_SBMBC,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_TEMP_TERM,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PORT_TASKQ,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PROCS_TPROC_EL,
  ERTS_ALC_T_PROCS_CNKINF,
  ERTS_ALC_T_PROCS_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_BINARY_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_MISC_AUX_WORK,
  ERTS_ALC_T_THR_Q_SL,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_XPORTS_LIST,
  ERTS_ALC_T_T_THR_PRGR_DATA,
  ERTS_ALC_T_ETHR_SL,
  ERTS_ALC_T_SL_PTIMER,
  ERTS_ALC_T_SYS_MSG_Q,
  ERTS_ALC_T_AINFO_REQ,
  ERTS_ALC_T_SCHED_WTIME_REQ,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_THR_Q_EL,
  ERTS_ALC_T_THR_Q,
  ERTS_ALC_T_PORT_LOCK,
  ERTS_ALC_T_DRIVER_LOCK,
  ERTS_ALC_T_ETHR_STD,
  ERTS_ALC_T_LL_PTIMER,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_DB_HEIR_DATA,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_ASYNC_DATA,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_SLP_INFO,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_CPU_GRPS_MAP,
  ERTS_ALC_T_AUX_WORK_TMO,
  ERTS_ALC_T_MISC_AUX_WORK_Q,
  ERTS_ALC_T_THR_Q_LL,
  ERTS_ALC_T_PROC_LCK_WTR,
  ERTS_ALC_T_RUNQ_BLNS,
  ERTS_ALC_T_THR_PRGR_IDATA,
  ERTS_ALC_T_THR_PRGR_DATA,
  ERTS_ALC_T_ETHR_LL,
  ERTS_ALC_T_FP_EXCEPTION,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_LL_TEMP_TERM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_BEAM_REGISTER,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_THR_Q_EL_SL,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "hipe_data",
  "putenv_string",
  "small_block_mbc",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "port_call_buf",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "temp_term",
  "sys_read_buf",
  "environment",
  "pending_suspend",
  "proc_list",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "port_task",
  "port_task_queue",
  "misc_op_list",
  "port_names",
  "processes_term_proc_el",
  "processes_chunk_info",
  "processes_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "binary_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "misc_aux_work",
  "short_lived_thr_queue",
  "async",
  "extra_port_list",
  "temp_thr_prgr_data",
  "ethread_short_lived",
  "ptimer_sl",
  "system_messages_queue",
  "alloc_info_request",
  "sched_wall_time_request",
  "fd_list",
  "pollset_update_req",
  "reg_proc",
  "link_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "driver",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_handle",
  "port_data_lock",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "zlib",
  "thr_q_element",
  "thr_queue",
  "port_lock",
  "driver_lock",
  "ethread_standard",
  "ptimer_ll",
  "ddll_processes",
  "monitor_lh",
  "nlink_lh",
  "db_heir_data",
  "fd_entry_buf",
  "port_report_exit",
  "atom_entry",
  "module_entry",
  "fun_entry",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "internal_async_data",
  "db_tabs",
  "instr_info",
  "scheduler_sleep_info",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "cpu_groups_map",
  "aux_work_timeouts",
  "misc_aux_work_q",
  "long_lived_thr_queue",
  "proc_lock_waiter",
  "run_queue_balancing",
  "thr_prgr_internal_data",
  "thr_prgr_data",
  "ethread_long_lived",
  "fp_exception",
  "code",
  "db_match_pseudo_proc",
  "scheduler_data",
  "ll_temp_term",
  "export_entry",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "fd_tab",
  "cs_prog_path",
  "beam_register",
  "heap",
  "old_heap",
  "heap_frag",
  "db_tab",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "msg_ref",
  "sl_thr_q_element",
  "monitor_sh",
  "nlink_sh",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "drv_internal",
  "nif_internal",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "sbmbc_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
